function getWeekDayName(weekday) {
  if (weekday == 0) return "Sunday";
  if (weekday == 1) return "Monday";
  if (weekday == 2) return "Tuesday";
  if (weekday == 3) return "Wednesday";
  if (weekday == 4) return "Thursday";
  if (weekday == 5) return "Friday";
  if (weekday == 6) return "Saturday";
}

function getMonthName(month, type){
  var monthName = ['January', 'Feburary', 'March',
                   'April', 'May', 'June',
                   'July', 'August', 'September',
                   'October', 'November', 'December'];

  var flowerMonthName = ['柳', '杏', '桃',
                         '槐','榴', '荷',
                         '巧','桂', '菊',
                         '陽', '葭', '梅'];

  if (type == 'english')  return monthName[month];
  else return flowerMonthName[month] + "月";

}

function getOrdinaryString(date) {
  switch (date){
    case 1: case 11: case 21: case 31: return "st";
    case 2: case 12: case 22: return "nd";
    case 3: case 13: case 23: return "rd";
    default: return "th";
  }
}

function updateDate() {
  var today = new Date();
  document.getElementById("cur-year").innerHTML = today.getFullYear();
  document.getElementById("cal-year").innerHTML = today.getFullYear();
  document.getElementById("back-year").innerHTML = today.getFullYear();
  document.getElementById("cur-month").innerHTML = getMonthName(today.getMonth(), 'english');
  document.getElementById("cal-month").innerHTML = getMonthName(today.getMonth(), 'english');
  document.getElementById("cur-day").innerHTML =  getWeekDayName( today.getDay() );
  document.getElementById("cur-date").innerHTML = today.getDate() + "<sup>" + getOrdinaryString(today.getDate()) + "</sup>";
}

document.onkeydown = function(e) {
    switch (e.keyCode) {
        case 37: previousMonth(); break;
        case 39: nextMonth(); break;
    }
};

function previousMonth(){
  thisMonth--;
  if (thisMonth == -1) {
    thisMonth = 11;
    thisYear--;
  }
  fillInMonth();
  console.log("Prev...");
}

function nextMonth(){
  thisMonth++;
  if (thisMonth == 12) {
    thisMonth = 0;
    thisYear++;
  }
  fillInMonth();
  console.log("Next...");
}

function fillInMonth() {
  document.getElementById("cal-year").innerHTML = thisYear;
  document.getElementById("cal-month").innerHTML = getMonthName(thisMonth, 'english');

  var days = document.getElementsByTagName("td"); //取得月曆中42個td標籤物件陣列，並用變數days指向該物件
  var thisYearMonthFirstDate = new Date(thisYear, thisMonth,1);
  var startDate = thisYearMonthFirstDate.getDay(); //取得今年今月1日是禮拜幾
  var monthDays = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]; //儲存每月的天數，其中2月為28或29
  if ((thisYear % 4 == 0 && thisYear % 100 !=0) || (thisYear % 400 ==0)) monthDays[1]= 29; //若是閏年，2月設為29日

  if (document.getElementById("current-day")) {
      document.getElementById("current-day").removeAttribute("id");
  }

  if (thisMonth == today.getMonth()) {
    thisDate = today.getDate(); //取得今天的數字
    days[startDate + thisDate - 1].setAttribute("id", "current-day");
  }
  for (var i = 0; i <= 41; i++){
    if (days[i].classList.contains("color")) days[i].classList.remove("color");
  }

  //填上個月的日期：上個月的最後一天填入days[startDate-1]，一直到days[0]…
  for(var day = monthDays[(thisMonth-1) >= 0 ? (thisMonth-1) :  11], i = startDate - 1; i >= 0; day--, i--){
    days[i].innerHTML = day;
    days[i].classList.add("color"); //加入color的類別選擇子
    days[i].classList.remove("prev-month-last-day");
  }
  if (startDate > 0) days[startDate - 1].classList.add("prev-month-last-day");

  //填當月的日期：從1填入days[startDate+i-1]~當月的最後一天days[startDate+i-1]
  for (var i = 1; i <= monthDays[thisMonth]; i++){
    days[startDate + i - 1].innerHTML = i;
  }

  //填下個月的日期：從1填入days[startDate+i]~days[41]
  for(i = startDate + i - 1, day = 1; i <= 41; i++, day++){
    days[i].innerHTML = day;
    days[i].classList.add("color"); //加入color的類別選擇子
  }
  changeColor();
}
